/**
*
* Copyright (c) 2012 TOTAL IMMERSION, All Rights Reserved
* No part of this software and its documentation may be used, copied,
* modified, distributed and transmitted, in any form or by any means,
* without the prior written permission of TOTAL IMMERSION
*
* TOTAL IMMERSION, 22 rue Edouard Nieuport 92150 SURESNES FRANCE
* contact@t-immersion.com www.t-immersion.com
*
*/


#include "dcvRender.h"
#include <tchar.h>


#define TEXT_HEIGHT 16
double focaleX = 900;
double focaleY = 900;

dcvRender::dcvRender(pxcCHAR *title):UtilRender(title), m_tracker(0) {
}

void _proj3to2(double position[3], int& posx, int& posy, int cx=0, int cy=0)
{
	posx = cx+(int)(position[0]/position[2]*focaleX);
	posy = cy+(int)(position[1]/position[2]*focaleY);
}

void dcvRender::DrawMore(HDC hdc, double sx, double sy) {
	RECT Wrect;

	HGDIOBJ hbrushOld; 
	HBRUSH hbrush; 

    GetClientRect(m_hWnd, &Wrect);
	int dx = (int) Wrect.right/2;
	int dy = (int) Wrect.bottom/2;

	PXCDCVTracker::TrackingStatus status = m_tracker->GetTargetStatus(0);
	pxcI32 index = m_tracker->GetTrackedKeyFrameIndex(0);
	if ((status == PXCDCVTracker::STATUS_TRACKING) || (index != -1))
	{
		int targetTracked = m_tracker->GetTrackedKeyFrameIndex(0);
		const pxcCHAR* label = m_tracker->GetTargetName(0);
		double position[3];
		m_tracker->GetTrackedPosition(0, position);
		PXCDCVTracker::ProfileInfo	pinfo;
		m_tracker->QueryProfile(&pinfo);
		focaleX = pinfo.inputs.devCaps[2].value;
		focaleY = pinfo.inputs.devCaps[3].value;

		int x0, y0;
		_proj3to2(position, x0, y0, dx, dy);
        int rx=20*50/position[2];
        int ry=20*50/position[2];

		hbrush = CreateSolidBrush(RGB(255, 255, 0));
		hbrushOld = (HBRUSH)SelectObject(hdc, hbrush);

		Ellipse(hdc,x0-rx,y0-ry,x0+rx,y0+ry);
		SelectObject(hdc, hbrushOld);

		TextOut(hdc, x0, y0, label, _tcslen(label));

		hbrush = CreateSolidBrush(RGB(0, 0, 0));
		hbrushOld = (HBRUSH)SelectObject(hdc, hbrush);

		Ellipse(hdc,x0-rx*0.5,y0-ry*0.5,x0-rx*0.5+20,y0-ry*0.5+20);
		SelectObject(hdc, hbrushOld);

		hbrush = CreateSolidBrush(RGB(0, 0, 0));
		hbrushOld = (HBRUSH)SelectObject(hdc, hbrush);

		Ellipse(hdc,x0-rx*0.5+rx*0.7,y0-ry*0.5,x0-rx*0.5+rx*0.7+20,y0-ry*0.5+20);
		SelectObject(hdc, hbrushOld);

	
//		RECT rect={ (LONG)(x0-rx), (LONG)(y0-ry), (LONG)(x0+rx), (LONG)(y0+ry) };
//		DrawEdge(hdc, &rect, EDGE_RAISED, BF_TOP|BF_RIGHT|BF_LEFT|BF_BOTTOM);


		double orientation[4];
		m_tracker->GetTrackedOrientation(0, orientation);
		printf("Target tracked : %d, position {%f:3, %f:3, %f:3}, orientation {%f:3, %f:3, %f:3, %f:3}\n", targetTracked, position[0], position[1], position[2], 
			orientation[0],orientation[1],orientation[2],orientation[3]);
	}


}

